Dashamir Hoxha

AlbaniaOnline SP


          <dhoxha@albaniaonline.net>
        

Copyright (C) 2008 Dashamir Hoxha. Permission is granted to copy, distribute
and/or modify this document under the terms of the GNU Free Documentation
License, Version 1.1 or any later version published by the Free Software
Foundation; with no Invariant Sections, with no Front-Cover Texts, and with no
Back-Cover Texts. A copy of the license is included in the section entitled
"GNU Free Documentation License."

Abstract

This manual describes how to set up a HotSpot service, using FreeRadius for
AAA, and managing client accounts in radius with HotSpot Manager.

-------------------------------------------------------------------------------

Table of Contents

1. Introduction
2. FreeRADIUS

    Installing
    Testing
    Using MySQL
    Testing MySQL

3. HotSpot Server

    ChilliSpot

        Introduction
        Installing and Configuring
        Firewall Setup
        UAM Authentication Web Server
        Configuring FreeRADIUS
        Referencies

    CoovaChilli

        Introduction
        Installing
        Configuration
        Referencies

    CoovaAP

        Introduction
        Installing
        Configuration
        Radius Configuration
        Login Page
        Quick Config
        Referencies

    MikroTik

        Referencies

4. Application

    Radius SQL API

A. GNU Free Documentation License

    ADDENDUM: How to use this License for your documents

Chapter 1. Introduction

Chapter 2. FreeRADIUS

Table of Contents

Installing
Testing
Using MySQL
Testing MySQL

Installing

I installed FreeRADIUS on Fedora. First I installed the packages freeradius and
freeradius-mysql :

bash# yum install freeradius freeradius-mysql

Then I enabled the service radiusd and started it:

bash# /sbin/chkconfig --list radiusd
bash# /sbin/chkconfig radiusd on
bash# /sbin/chkconfig --list radiusd

bash# /sbin/service radiusd start

Since freeradius uses the ports 1812 and 1813 (see e.g. the file /etc/services
), I had to open these ports in the firewall, both for tcp and udp . In order
to do this, I edited the file /etc/sysconfig/iptables and added there these
lines:

-A RH-Firewall-1-INPUT -m state --state NEW -m tcp -p tcp --dport 1812 -j ACCEPT
-A RH-Firewall-1-INPUT -m udp -p udp --dport 1812 -j ACCEPT
-A RH-Firewall-1-INPUT -m state --state NEW -m tcp -p tcp --dport 1813 -j ACCEPT
-A RH-Firewall-1-INPUT -m udp -p udp --dport 1813 -j ACCEPT

To apply these modifications in firewall, I restarted the service iptables:

bash# /sbin/service iptables restart

Tip

To check that the ports 1812 and 1813 are open in the firewall, we can use one
of these commands:

bash# /sbin/service iptables status | grep 1812
bash# /sbin/iptables-save | grep 1812

Testing

Just to test that FreeRADIUS is correctly installed and works, we can make a
simple configuration using the standard text files, like this:

  * Edit the file /etc/raddb/clients.conf . At the section client 127.0.0.1
    modify the value of secret , for example make it local1 . The entry client
    127.0.0.1 { . . . } will allow the localhost to use the radius service.

  * Edit the file /etc/raddb/users . Uncomment there the test user steve (or
    create another user with similar details). It should look like this:

    steve   Cleartext-Password := "testing"
            Service-Type = Framed-User,
            Framed-Protocol = PPP,
            Framed-IP-Address = 172.16.3.33,
            Framed-IP-Netmask = 255.255.255.0,
            Framed-Routing = Broadcast-Listen,
            Framed-Filter-Id = "std.ppp",
            Framed-MTU = 1500,
            Framed-Compression = Van-Jacobsen-TCP-IP

  * Edit /etc/raddb/radiusd.conf and make sure that authorization using files
    is enabled. (It should be enabled by default, so in general you don't need
    to modify anything.)

Now we can use the command radtest to request access for user steve with
password testing :

bash# radtest --help
bash# radtest steve testing 127.0.0.1 10 local1
bash# radtest steve testing localhost 10 local1
bash# radtest steve testingX 127.0.0.1 10 local1
bash# radtest steve testing 127.0.0.1 10 local1X

In the first and second tests you should get the answer 'Access-Accept'. In the
last two tests you should get the answer 'Access-Reject'.

Tip

In order to get more details about what happens in the server, run radiusd in
debug mode. First stop the service: /sbin/service radiusd stop , then run it
like this: /usr/sbin/radiusd -x or /usr/sbin/radiusd -X .

Note

If you have Windows, you may also wish to use NTradPing (downloadable from
MasterSoft ) instead of radtest. If you do this, or test from any other
machine, remember to put your PC (or the other machine) in your NAS list in the
file /etc/raddb/clients.conf .

Using MySQL

Now that radius is installed and we have tested that it works correctly, we can
create a mysql database for it and configure radius to use this database.

  * First let's create a new database and a new database user:

    bash$ mysql -p -u root
    mysql> CREATE DATABASE radiusdb;
    mysql> GRANT ALL ON radiusdb.* TO raduser@localhost IDENTIFIED BY "radpass";
    mysql> exit;

  * Now lets create the tables of the database by running the SQL script file
    that is in the directory freeradius/doc/examples/:

    bash$ mysql -p -u root -D radiusdb < /usr/share/doc/freeradius-1.1.6/examples/mysql.sql

  * We should modify now /etc/raddb/sql.conf by setting there the database, the
    username and the password that are needed to connect to the mysql server:

            # Connect info
            server = "localhost"
            login = "raduser"
            password = "radpass"

            # Database table configuration
            radius_db = "radiusdb"

    Note

    For testing/debug purposes, change sqltrace to yes. Then, freeradius will
    dump all SQL commands to the debug output.

    Note

    You may also need to modify the line about sql_user_name in this file.

  * Edit the file /etc/raddb/radiusd.conf and make there these modifications:

      o Uncomment the line saying 'sql' in the authorize{} section and comment
        the line saying 'files'.

      o Also uncomment the line saying 'sql' to the accounting{} section to
        tell FreeRADIUS to store accounting records in SQL as well. This file
        should then look something like this:

        authorise {
               preprocess
               chap
               mschap
               suffix
               eap
               # files
               sql
               pap
        }

        accounting {
               # We leave "detail" enabled to _additionally_ log accounting to /var/log/radius/radacct
               detail
               sql
        }

Testing MySQL

Enter some data in the database:

bash$ mysql -u raduser -p radpassw
mysql> USE radiusdb;
mysql> SHOW TABLES;
mysql> INSERT INTO usergroup (UserName, GroupName)
   --> VALUES ("radiustest", "testgroup");
mysql> SELECT * FROM usergroup;
mysql> INSERT INTO radcheck (UserName, Attribute, Value)
   --> VALUES ("radiustest", "Password", "testpassword");
mysql> SELECT * FROM radcheck;
mysql> INSERT INTO radgroupreply (GroupName, Attribute, op, Value)
   --> VALUES ("testgroup","Framed-Compression","==","Van-Jacobsen-TCP-IP");
mysql> INSERT INTO radgroupreply (GroupName, Attribute, op, Value)
   --> VALUES ("testgroup","Framed-Protocol","==","PPP");
mysql> INSERT INTO radgroupreply (GroupName, Attribute, op, Value)
   --> VALUES ("testgroup","Framed-MTU","==","1500");
mysqk> INSERT INTO radgroupreply (GroupName, Attribute, op, Value)
   --> VALUES ("testgroup","Service-Type","==","Framed-User");
mysql> quit;

Then stop the service /sbin/service radiusd stop and run radiusd in debug mode:
/usr/sbin/radiusd -x or /usr/sbin/radiusd -X .

Now check access for the user radiustest with password testpassword :

bash# radtest radiustest testpassword localhost 10 local1
Sending Access-Request of id 224 to 127.0.0.1 port 1812
        User-Name = "radiustest"
        User-Password = "testpassword"
        NAS-IP-Address = 255.255.255.255
        NAS-Port = 10
rad_recv: Access-Accept packet from host 127.0.0.1:1812, id=224, length=44
        Framed-Compression = Van-Jacobson-TCP-IP
        Framed-Protocol = PPP
        Framed-MTU = 1500
        Service-Type = Framed-User

Chapter 3. HotSpot Server

Table of Contents

ChilliSpot

    Introduction
    Installing and Configuring
    Firewall Setup
    UAM Authentication Web Server
    Configuring FreeRADIUS
    Referencies

CoovaChilli

    Introduction
    Installing
    Configuration
    Referencies

CoovaAP

    Introduction
    Installing
    Configuration
    Radius Configuration
    Login Page
    Quick Config
    Referencies

MikroTik

    Referencies

ChilliSpot

Introduction

ChilliSpot is used as an access point controller in a wireless LAN. A typical
network architecture is shown in the figure below. A wireless client can
establish a wireless connection to an access point, but in order to reach the
External Network it first has to authenticate with Chilli.

                                 [chillispot]

Three different networks are involved in the architecture:

  * External Network . The external network is typically the Internet or a
    corporate intranet. Access to the external network is guarded by Chilli
    which only allows traffic from authenticated wireless clients to pass.

  * Internal Network . The internal network is connecting the access points
    with Chilli. It is used for forwarding Ethernet frames between Chilli and
    the wireless clients as well as for IP management traffic to and from the
    access points.

  * Wireless Network : The wireless clients are connected to the wireless
    network, and the access points serve as bridges between the internal
    network and the wireless network. This enables forwarding of Ethernet
    frames between Chilli and the wireless clients. In the example above the
    wireless network is allocated the address range 192.168.182.0/24.

In order to function properly Chilli depends on a few external servers:

  * DNS Server . When accessing the external network the wireless clients rely
    on one or several DNS servers for resolving domain names to IP addresses.
    The wireless clients are informed of the DNS server IP addresses by the
    Chilli. Before you start the installation of ChilliSpot you need to
    determine the IP address of at least one DNS server which can be used by
    the wireless clients. If you don't specify a DNS server Chilli will use the
    DNS server which is reported by the underlying operating system.

  * UAM Server . When a user logs on he is redirected to an authentication web
    server which queries the user for her username and password. If a separate
    uam server is not available it is possible to install one on the Chilli
    server.

  * Radius Server . User credentials are stored in one or several radius
    servers. Whenever a wireless client attempts to connect to the network
    Chilli will contact a radius server in order to validate the user
    credentials. If a separate radius server is not available it is possible to
    install one on the Chilli server.

Generally the access points should be configured with open authentication and
no encryption. Authentication is handled by Chilli. For better security, the
access points should be configured for Wireless Protected Access.

Installing and Configuring

  * Download from http://www.chillispot.info/download.html the latest RPM
    package and install it with the command:

    rpm -Uhv chillispot-1.1.0.i386.rpm

  * During installation of ChilliSpot a configuration file was copied to /etc/
    chilli.conf . You need to edit this file. A description of each option is
    given in the man page ( man chilli ). As a start you can leave most of the
    parameters as they are.

      o If you use an external radius server you need to modify the parameters:
        radiusserver1 , radiusserver2 , radiussecret . If you are not using an
        external radius server you can leave these parameters as they are, as
        we will install a radius server later during the installation.

      o If you use an external UAM server you need to modify the parameter
        uamserver . If you are not using an external UAM server you can leave
        this parameters as it is, as we will install an UAM server later during
        the installation.

  * In order to automate startup of chilli issue the command:

    chkconfig chilli on

    ChilliSpot will start next time you reboot the system, or you can start it
    directly by issuing the command

    service chilli start

Firewall Setup

It is important to protect ChilliSpot from unauthorized traffic. No single
firewall ruleset can satisfy all network configurations, and generally you
should write your own set of rules. As a starting point you can use the script
located in: /usr/share/doc/chillispot-1.1.0/firewall.iptables . You can edit
this file to suit your own configuration or simply use it without modification.

Once you have edited the file install it by issuing the following commands:

service iptables stop
/usr/share/doc/chillispot-1.1.0/firewall.iptables
service iptables save

This will first clear the current firewall rules, install the new rules and
finally save the rules so that they will be restored whenever the system is
rebooted.

In order for ChilliSpot to forward network packets, IP forwarding must be
turned on in the kernel. You need to change this line in /etc/sysctl.conf :

net.ipv4.ip_forward = 1

The changes take effect when you reboot the system, or you can activate them
directly by issuing the command

/sbin/sysctl -p

UAM Authentication Web Server

We will now configure Apache to request username and password from the wireless
clients:

  * During installation of ChilliSpot a cgi script was placed in /usr/share/doc
    /chillispot-1.1.0/hotspotlogin.cgi . Copy this script to /var/www/cgi-bin/
    hotspotlogin.cgi on the web server.

  * We need to tell Chilli about the location of the authentication server.
    This is done by uncommenting and editing the following line in /etc/
    chilli.conf :

    uamserver https://192.168.182.1/cgi-bin/hotspotlogin.cgi

  * We need to restart chilli in order for the configuration changes to take
    effect:

    service chilli restart

Configuring FreeRADIUS

We will now configure FreeRADIUS to authenticate the HotSpot users.

  * Insert users in the radius database.

  * Edit raddb/clients.conf in order to configure the IP address and shared
    secret of chilli. The secret must match the radiussecret parameter in /etc/
    chilli.conf.

  * Tell Chilli about the location of the radius server. This is done by
    uncommenting and editing the following lines in /etc/chilli.conf :

    radiusserver1 127.0.0.1
    radiusserver2 127.0.0.1
    radiussecret testing123

  * Restart chilli in order for the configuration changes to take effect:
    service chilli restart.

Referencies

Referencies:

  * http://www.chillispot.info/download.html

  * http://www.chillispot.info/release.html#mozTocId867888

  * http://global.freifunk.net/item/chillispot_howto

CoovaChilli

Introduction

CoovaChilli is an open-source software access controller, based on the popular
ChilliSpot project. It is a feature rich software access controller that
provides a captive portal / walled-garden environment and uses RADIUS for
access provisioning.

                                   [Chilli]

Installing

  * From a RPM package:

    wget http://ap.coova.org/chilli/coova-chilli-1.0.11-1.i386.rpm
    sudo rpm -U coova-chilli-1.0.11-1.i386.rpm

  * Building from source:

    wget http://ap.coova.org/chilli/coova-chilli-1.0.11.tar.gz
    tar xzf coova-chilli-1.0.11.tar.gz
    cd coova-chilli-1.0.11
    ./configure
    make
    sudo make install

  * Building the last version from SVN:

    svn checkout http://dev.coova.org/svn/coova-chilli/
    cd coova-chilli
    sh bootstrap
    ./configure
    make
    sudo make install

    By default it will be installed on /usr/local/ .

Configuration

  * Go to /etc/chilli/ (or /usr/local/etc/chilli/ ) and make a copy of defaults
    to config :

    cd /etc/chilli/
    cp defaults config

  * Modify /etc/chilli/config like this:

    ###
    #   Local Network Configurations
    #

    HS_WANIF=eth0            # WAN Interface toward the Internet
    HS_LANIF=eth1              # Subscriber Interface for client devices
    HS_NETWORK=10.1.0.0        # HotSpot Network (must include HS_UAMLISTEN)
    HS_NETMASK=255.255.255.0 # HotSpot Network Netmask
    HS_UAMLISTEN=10.1.0.1      # HotSpot IP Address (on subscriber network)
    HS_UAMPORT=3990          # HotSpot Port (on subscriber network)

    ###
    #   HotSpot settings for simple Captive Portal
    #

    HS_UAMSECRET=

    HS_RADIUS=192.168.250.118
    HS_RADIUS2=192.168.250.118
    HS_RADSECRET=test

    HS_NASIP=192.168.252.46    # To explicitly set NAS-IP-Address

    #   The server to be used in combination with HS_UAMFORMAT to
    #   create the final chilli 'uamserver' url configuration.
    HS_UAMSERVER=192.168.252.45

    #   Use HS_UAMFORMAT to define the actual captive portal url.
    #   Shell variable replacement takes place when evaluated, so here
    #   HS_UAMSERVER is escaped and later replaced by the pre-defined
    #   HS_UAMSERVER to form the actual "--uamserver" option in chilli.
    HS_UAMFORMAT=http://\$HS_UAMSERVER/uam/

    #   Same principal goes for HS_UAMHOMEPAGE.
    HS_UAMHOMEPAGE=http://\$HS_UAMLISTEN:\$HS_UAMPORT/www/coova.html

    HS_LOC_NAME="AOLSP HotSpot"         # WISPr Location Name and used in portal

    Caution

    Be sure to leave empty HS_UAMSECRET, since we are going to use the JSON
    interface , otherwise the users will fail to login .

  * Start the chilli service:

    chkconfig chilli on
    chkconfig --list chilli
    service chilli start
    service chilli status

    When the service is started, it will automatically create the configuration
    files hs.conf , local.conf and main.conf from config . When the config is
    modified, the chilli service must be restarted as well.

  * In the config file we have defined the uamserver like this:

    HS_UAMSERVER=192.168.252.45
    HS_UAMFORMAT=http://\$HS_UAMSERVER/uam/

    This is a webserver different from the server where coova-chilli is
    installed. In this server we have to create an index.html file:

    mkdir -p /var/www/html/uam/
    cd /var/www/html/uam/
    wget http://coova.org/uam/
    wget http://coova.org/js/chilli.js

    Then, we should edit index.html to use chilli.js from local. We can also
    modify index.html as we like.

    Note

    The authentication page http://192.168.252.45/uam/index.html can actually
    be any page, enough that it contains the line:

    <script id='chillijs' src='chilli.js'></script>

    For more details see Any page a login page .

Referencies

  * CoovaChilli

  * CoovaChilli Documentation

  * CoovaChilli Development

  * CoovaChilli HowTo

  * CoovaAAA Captive Portal

  * CoovaChilli Forum

  * Any page a login page

  * CoovaChilli JSON Interface

CoovaAP

Introduction

CoovaAP Firmware is a linux system that can be installed in a wireless router.
In this system are included several packages/tools that extend and enhance the
features of the router. CoovaAP is an OpenWRT-based firmware designed
especially for HotSpots. It comes with the CoovaChilli access controller
built-in and makes it easily configurable. CoovaAP is perfect for just about
any HotSpot application - from WPA Enterprise (with RADIUS accounting) to Free
WiFi with Terms of Service acknowledgment to commercial HotSpot captive portal
applications. The configuration of the router is managed through a
web-interface, but it is also possible to login via ssh into the router.

The wireless routers that are supported by CoovaAP are: Linksys WRT54GL,
Linksys WRT54G, Linksys WRT54GS, Linksys WRT54GS v4, etc.

The key features of CoovaAP are:

  * Open-source, based on OpenWrt

  * Advanced Web-based Configuration

  * Easy HotSpot Configuration & Status

  * CoovaChilli Access Controller

  * Embedded Captive Portal

  * Facebook HotSpot Captive Portal

  * Integrated CoovaChilli with WPA

  * OpenID Authentication

  * Centralized CoovaChilli Configuration

  * WiFiDog Access Controller

  * PPTP VPN Client and Server

  * OpenVPN Client

  * Traffic Shaping

  * WDS HotSpot

For more details look at the CoovaAP homepage.

Installing

The installation is described very well in the page CoovaAP Firmware
Installation http://coova.org/wiki/index.php/Installation_Help.

Configuration

  * At System / Settings :

      System Settings
        Host Name            : LinkSys
        boot_wait            : Enabled
        Language            : English
     
      System Administration
        WAN SSH Access    : Enabled
        WAN Web Access    : HTTPS Only
        HotSpot SSH Access    : Enabled
        HotSpot LAN Web Access : HTTPS Only

  * At Network / DHCP :

      DHCP Settings
        LAN DHCP Services : Enabled
        Starting Address : 192.168.1.100
        Number of Addresses : 150

  * At Network / WAN :

      WAN Configuration
        Connection Type : Static IP
     
      IP Settings
        IP Address         : 192.168.25.31
        Netmask         : 255.255.255.0
        Default Gateway : 192.168.25.1

      DNS Servers
        192.168.25.101
        4.2.2.2

  * At Network Wireless :

      Wireless Configuration
        Wireless Interface : Enabled
        ESSID Broadcast : Show
        ESSID         : WiFi
        Channel         : 11
        Mode         : Access Point

      Encryption Settings
        Encryption Type : Disabled

  * At Network / Advanced Wireless :

      Settings
        Isolate WLAN clients : Enabled

  * At HotSpot / Configuration :

      HotSpot Configurations
        HotSpot Type : ChilliSpot UAM
        HotSpot Mode : LAN & Wireless

      ChilliSpot Configurations
        Auto Configuration : Web URL
        Web Config URL      : http://192.168.25.45/hotspot/config/

  * At HotSpot / Location :

      Hotspot Location
        Location Name : Location
        Location Address : Address
        Network Name : Network
        Country ISO Code    : AL

Radius Configuration

In the interface HotSpot / Configuration we have these settings:

  HotSpot Configurations
    HotSpot Type : ChilliSpot UAM
    HotSpot Mode : LAN & Wireless
 
  ChilliSpot Configurations
    Auto Configuration : Web URL
    Web Config URL : http://192.168.25.118/hsconfig/

The configuration of ChilliSpot (coova-chilli) is retrieved from the server
192.168.25.118 by http. The configuration file index.html in this server has
this content:

uamserver http://www.albaniaonline.net/hs/
radiusserver1 192.168.25.118
radiusserver2 192.168.25.118
radiussecret aolsecret
radiusnasid HotSpot
uamallowed www.albaniaonline.net

It contains the configuration of the radius server. The parameter uamserver
contains the URL of the web page that will be used by the clients to login to
internet.

In case that the configuration is different for different routers, then the
setting Web Config URL should be different, so that they can load different
configurations. This can be useful if we want to have a different radiusnasid
for different routers and a different (personalized) login page.

Login Page

The login page that is located at http://www.albaniaonline.net/hs/ consists of
an html and a javascript file, as described at CoovaChilli JSON Interface .

The content of the file index.htm is this:

<html>
<head>
<!--
      A purely HTML based captive portal using the JSON interface of CoovaChilli
-->
<title>coova hotspot</title>
<style><!--
body,td,a,p,h{
  font-family:arial,sans-serif;
}
body {
  text-align: center;
  padding-top: 30px;
  margin: auto;
  width: 50%;
}
#MyChilli {
  background: url("coova.jpg") right top no-repeat;
  margin: auto;
  text-align: left;
  padding: 10px 0 30px 0;
}
#locationName {
  height: 50px;
  font-size: 120%;
  font-weight: bold;
}
#chilliPage {
  border: 1px solid orange;
  padding: 20px 20px 20px 20px;
  margin-top: 20px;
}
#signUpRow {
  display: inline;
}
-->
</style>
</head>
<body>
<div id="MyChilli">

<div id="noLocation" style="display:none;">
<p style="padding-top: 100px;"><strong>You are not at a hotspot.</strong>
If you want to see a a sample login page using the <a href="http://coova.org/wiki/index.php/CoovaChilli/JSON">JSON interface</a>
of <a href="http://coova.org/wiki/index.php/CoovaChilli">CoovaChilli</a>,
then <a href="javascript: window.location = 'view-source:' + window.location.href;">view the source</a>
of this page.</p>
</div>

<h1>AlbaniaOnline SP Homepage</h1>
<script id='chillijs' src='chilli.js'></script>


</div>
</body>
</html>

The content of the file chilli.js is this:

if (navigator.appVersion.indexOf("MSIE")!=-1)
document.write("<script type='text/javascript' id='chillicontroller'></script>");

if (!window.queryObj) {
    window.queryObj = new Object();
    window.location.search.replace(new RegExp("([^?=&]+)(=([^&]*))?","g"), function($0,$1,$2,$3) { queryObj[$1] = $3; });
}

if (queryObj['uamip'] != null && queryObj['uamport'] != null) {
    var script = document.getElementById('chillicontroller');
    if (script == null) {
        script = document.createElement('script');
        script.id = 'chillicontroller';
        script.type = 'text/javascript';
        script.src = 'http://'+queryObj['uamip']+':'+queryObj['uamport']+'/www/chillijs.chi';

        var head = document.getElementsByTagName("head")[0];
        if (head == null) head = document.body;
        head.appendChild(script);
    }
    script.src = 'http://'+queryObj['uamip']+':'+queryObj['uamport']+'/www/chillijs.chi';
} else {
    var noLocation = document.getElementById("noLocation");
    if (noLocation != null && noLocation.style) {
       noLocation.style.display = 'inline';
    }

Quick Config

After a CoovaAP wireless router has been configured properly, its configuration
can be backup-ed in order to use it for quick reconfiguration of the device.
The configuration can be downloaded and uploaded at the interface System /
Config Management .

The configuration backup can also be used to configure quickly a new router. In
this case, these configuration settings should be modified manually:

  * IP Address at Network / WAN has to be modified.

  * HotSpot / Location can be modified.

  * Web Config URL at HotSpot / Configuration can be modified optionally, in
    case that we want to provide a customized login page, radius server, etc.

Referencies

  * CoovaAP Firmware

  * CoovaAP Firmware Installation

  * CoovaChilli JSON Interface

  * CoovaAP Forum

MikroTik

  * General network configuration:

    ### an address on the outside (WAN) interface of the mikrotik
    / ip address add address=192.168.25.120/24 interface=ether1

    ### add a gateway
    # / ip route add gateway=192.168.25.1

    ### set the DNS servers
    / ip dns set primary-dns=192.168.25.101 secondary-dns=4.2.2.2

  * Radius configuration:

    ### add another address for connecting to the radius server
    / ip address add address=192.168.255.1/24 interface=ether2

    ### add radius servers for any PPP service on mikrotik
    / radius add service=hotspot address=192.168.255.101 secret=radiussecret timeout=2000ms

    / radius incoming set accept=yes

  * Setup masquerading:

    ### setup NAT on the outside interface of the mikrotik
    / ip firewall nat add chain=srcnat out-interface=ether1 action=masquerade

    ### disable masquerading for the radius LAN (192.168.255.0/24)
    / ip firewall nat add chain=srcnat out-interface=ether1 src-address=192.168.255.0/24 action=return
    / ip firewall nat print
    / ip firewall nat move 1 0

  * Add a pool:

    ### add a pool
    / ip pool add name=pool0 ranges=192.168.10.0/16

  * Add a hotspot server profile:

    / ip hotspot profile add name="prof1" hotspot-address=192.168.10.1
         dns-name="hotspot1.al" html-directory=hotspot use-radius=yes radius-accounting=yes

  * Add a hotspot server:

    / ip hotspot add name="server1" interface=ether2 address-pool=pool1 profile=prof1

  * Add a user profile:

    / ip hotspot user profile add name="prof1" address-pool=pool1 transparent-proxy=no

  * Add a user:

    / ip hotspot user add server=server1 name="user1" password="passw1" profile=prof1

  * Modify the hotspot login pages.

Referencies

  * http://www.mikrotik.com/testdocs/ros/2.9/ip/hotspot.php

  * http://www.mikrotik.com/testdocs/ros/2.9/guide/aaa_hotspot.php

Chapter 4. Application

Table of Contents

Radius SQL API

Radius SQL API

  * procedure user_save(p_username varchar(64),
                        p_password varchar(253),
                        p_service  varchar(64),
                        p_domain   varchar(253) )

    Takes the parameters: username, password, service. In case that such a user
    exist, it is deleted first, and then new records about the user are
    inserted.

      Examples:
        + call radius.user_save('user-1','passw-1','test-1','domain-1');
            -- create the user 'user-1' which has access at 'domain-1'
        + call radius.user_save('user-1','xyz','test-1','domain-1');
            -- change the password of 'user-1'

  * function user_check(p_username varchar(64)) returns varchar(64)

    Used to check whether a user already exists in radiusdb (in the table
    radcheck). If there is such a user, then it returns its username.

     Examples:
        + select radius.user_check('user-1') as username;
            +----------+
            | username |
            +----------+
            | user-1   |
            +----------+
        + select radius.user_check('user-2') as username;
            +----------+
            | username |
            +----------+
            |          |
            +----------+

  * procedure user_get(p_username varchar(64),
                       p_service  varchar(64) )

    Returns the data of a given user. Parameters are username and service
    patterns. Matching is done with LIKE. The records that are returned have
    the fields: username, service

      Examples:
        + call user_get('user-1', '%');
            -- get the data of 'user-1'
        + call user_get('%', 'service-1');
            -- get the data of all the users that have the service 'service-1'
        + call user_get('%', '%');
            -- get the data of all the users

  * procedure user_del(p_username varchar(64))

    Delete the given user.

      Examples:
        + call radius.user_del('user-2');
            -- delete user 'user-2'

  * procedure service_save(p_service_name  varchar(64),
                           p_download_rate int(11),
                           p_upload_rate   int(11))

    Save (add or update) a service. Takes the parameters: service_name,
    download_rate, upload_rate. Download and upload rates are integers in Kbps.
    If a service with such a name already exists, it is deleted first.

      Examples:
        + call radius.service_save('test-1', 256, 128);
            -- create the service test-1 with 256Kbps download and 128Kbps upload
        + call radius.service_save('test-2', 512, 128);
            -- add another service
        + call radius.service_save('test-2', 512, 256);
            -- change the upload rate of the service test-2

  * procedure service_get(p_service_name varchar(64))

    Return a list of services that match the given parameter. Matching is done
    with LIKE. The result that is returned contains the fields: service,
    dwmload rate, upload rate, where the rates are integers of Kbps.

      Examples:
        + call radius.service_get('test-1');
            -- get the data of the service 'test-1'
        + call radius.service_get('%');
            -- get the data of all the services
            +----------+---------------+-------------+
            | service  | download_rate | upload_rate |
            +----------+---------------+-------------+
            | test-1   |           256 |         128 | 
            | test-2   |           512 |         256 | 
            +----------+---------------+-------------+

  * procedure service_del(p_service varchar(64))

    Delete the service with the given name.

      Examples:
        + call radius.service_del('test-2');
            -- delete the service that is named 'test-2'

  * procedure change_service_name(p_old_service varchar(64)
                                  p_new_service varchar(64))

    Changes the name of a service, so that all the clients that were using the
    old service now use the new service.

      Examples:
        + call radius.change_service_name('test-2', 'test2');
            -- change the name of the service 'test-2' to 'test2'

Appendix A. GNU Free Documentation License

Table of Contents

ADDENDUM: How to use this License for your documents

Version 1.2, November 2002

Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
59 Temple Place, Suite 330, Boston, MA  02111-1307, USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

 1. PREAMBLE

    The purpose of this License is to make a manual, textbook, or other
    functional and useful document free in the sense of freedom: to assure
    everyone the effective freedom to copy and redistribute it, with or without
    modifying it, either commercially or noncommercially. Secondarily, this
    License preserves for the author and publisher a way to get credit for
    their work, while not being considered responsible for modifications made
    by others.

    This License is a kind of "copyleft", which means that derivative works of
    the document must themselves be free in the same sense. It complements the
    GNU General Public License, which is a copyleft license designed for free
    software.

    We have designed this License in order to use it for manuals for free
    software, because free software needs free documentation: a free program
    should come with manuals providing the same freedoms that the software
    does. But this License is not limited to software manuals; it can be used
    for any textual work, regardless of subject matter or whether it is
    published as a printed book. We recommend this License principally for
    works whose purpose is instruction or reference.

 2. APPLICABILITY AND DEFINITIONS

    This License applies to any manual or other work, in any medium, that
    contains a notice placed by the copyright holder saying it can be
    distributed under the terms of this License. Such a notice grants a
    world-wide, royalty-free license, unlimited in duration, to use that work
    under the conditions stated herein. The "Document", below, refers to any
    such manual or work. Any member of the public is a licensee, and is
    addressed as "you". You accept the license if you copy, modify or
    distribute the work in a way requiring permission under copyright law.

    A "Modified Version" of the Document means any work containing the Document
    or a portion of it, either copied verbatim, or with modifications and/or
    translated into another language.

    A "Secondary Section" is a named appendix or a front-matter section of the
    Document that deals exclusively with the relationship of the publishers or
    authors of the Document to the Document's overall subject (or to related
    matters) and contains nothing that could fall directly within that overall
    subject. (Thus, if the Document is in part a textbook of mathematics, a
    Secondary Section may not explain any mathematics.) The relationship could
    be a matter of historical connection with the subject or with related
    matters, or of legal, commercial, philosophical, ethical or political
    position regarding them.

    The "Invariant Sections" are certain Secondary Sections whose titles are
    designated, as being those of Invariant Sections, in the notice that says
    that the Document is released under this License. If a section does not fit
    the above definition of Secondary then it is not allowed to be designated
    as Invariant. The Document may contain zero Invariant Sections. If the
    Document does not identify any Invariant Sections then there are none.

    The "Cover Texts" are certain short passages of text that are listed, as
    Front-Cover Texts or Back-Cover Texts, in the notice that says that the
    Document is released under this License. A Front-Cover Text may be at most
    5 words, and a Back-Cover Text may be at most 25 words.

    A "Transparent" copy of the Document means a machine-readable copy,
    represented in a format whose specification is available to the general
    public, that is suitable for revising the document straightforwardly with
    generic text editors or (for images composed of pixels) generic paint
    programs or (for drawings) some widely available drawing editor, and that
    is suitable for input to text formatters or for automatic translation to a
    variety of formats suitable for input to text formatters. A copy made in an
    otherwise Transparent file format whose markup, or absence of markup, has
    been arranged to thwart or discourage subsequent modification by readers is
    not Transparent. An image format is not Transparent if used for any
    substantial amount of text. A copy that is not "Transparent" is called
    "Opaque".

    Examples of suitable formats for Transparent copies include plain ascii
    without markup, Texinfo input format, LaTeX input format, SGML or XML using
    a publicly available DTD, and standard-conforming simple HTML, PostScript
    or PDF designed for human modification. Examples of transparent image
    formats include PNG, XCF and JPG. Opaque formats include proprietary
    formats that can be read and edited only by proprietary word processors,
    SGML or XML for which the DTD and/or processing tools are not generally
    available, and the machine-generated HTML, PostScript or PDF produced by
    some word processors for output purposes only.

    The "Title Page" means, for a printed book, the title page itself, plus
    such following pages as are needed to hold, legibly, the material this
    License requires to appear in the title page. For works in formats which do
    not have any title page as such, "Title Page" means the text near the most
    prominent appearance of the work's title, preceding the beginning of the
    body of the text.

    A section "Entitled XYZ" means a named subunit of the Document whose title
    either is precisely XYZ or contains XYZ in parentheses following text that
    translates XYZ in another language. (Here XYZ stands for a specific section
    name mentioned below, such as "Acknowledgements", "Dedications",
    "Endorsements", or "History".) To "Preserve the Title" of such a section
    when you modify the Document means that it remains a section "Entitled XYZ"
    according to this definition.

    The Document may include Warranty Disclaimers next to the notice which
    states that this License applies to the Document. These Warranty
    Disclaimers are considered to be included by reference in this License, but
    only as regards disclaiming warranties: any other implication that these
    Warranty Disclaimers may have is void and has no effect on the meaning of
    this License.

 3. VERBATIM COPYING

    You may copy and distribute the Document in any medium, either commercially
    or noncommercially, provided that this License, the copyright notices, and
    the license notice saying this License applies to the Document are
    reproduced in all copies, and that you add no other conditions whatsoever
    to those of this License. You may not use technical measures to obstruct or
    control the reading or further copying of the copies you make or
    distribute. However, you may accept compensation in exchange for copies. If
    you distribute a large enough number of copies you must also follow the
    conditions in section 3.

    You may also lend copies, under the same conditions stated above, and you
    may publicly display copies.

 4. COPYING IN QUANTITY

    If you publish printed copies (or copies in media that commonly have
    printed covers) of the Document, numbering more than 100, and the
    Document's license notice requires Cover Texts, you must enclose the copies
    in covers that carry, clearly and legibly, all these Cover Texts:
    Front-Cover Texts on the front cover, and Back-Cover Texts on the back
    cover. Both covers must also clearly and legibly identify you as the
    publisher of these copies. The front cover must present the full title with
    all words of the title equally prominent and visible. You may add other
    material on the covers in addition. Copying with changes limited to the
    covers, as long as they preserve the title of the Document and satisfy
    these conditions, can be treated as verbatim copying in other respects.

    If the required texts for either cover are too voluminous to fit legibly,
    you should put the first ones listed (as many as fit reasonably) on the
    actual cover, and continue the rest onto adjacent pages.

    If you publish or distribute Opaque copies of the Document numbering more
    than 100, you must either include a machine-readable Transparent copy along
    with each Opaque copy, or state in or with each Opaque copy a
    computer-network location from which the general network-using public has
    access to download using public-standard network protocols a complete
    Transparent copy of the Document, free of added material. If you use the
    latter option, you must take reasonably prudent steps, when you begin
    distribution of Opaque copies in quantity, to ensure that this Transparent
    copy will remain thus accessible at the stated location until at least one
    year after the last time you distribute an Opaque copy (directly or through
    your agents or retailers) of that edition to the public.

    It is requested, but not required, that you contact the authors of the
    Document well before redistributing any large number of copies, to give
    them a chance to provide you with an updated version of the Document.

 5. MODIFICATIONS

    You may copy and distribute a Modified Version of the Document under the
    conditions of sections 2 and 3 above, provided that you release the
    Modified Version under precisely this License, with the Modified Version
    filling the role of the Document, thus licensing distribution and
    modification of the Modified Version to whoever possesses a copy of it. In
    addition, you must do these things in the Modified Version:

     A. Use in the Title Page (and on the covers, if any) a title distinct from
        that of the Document, and from those of previous versions (which
        should, if there were any, be listed in the History section of the
        Document). You may use the same title as a previous version if the
        original publisher of that version gives permission.

     B. List on the Title Page, as authors, one or more persons or entities
        responsible for authorship of the modifications in the Modified
        Version, together with at least five of the principal authors of the
        Document (all of its principal authors, if it has fewer than five),
        unless they release you from this requirement.

     C. State on the Title page the name of the publisher of the Modified
        Version, as the publisher.

     D. Preserve all the copyright notices of the Document.

     E. Add an appropriate copyright notice for your modifications adjacent to
        the other copyright notices.

     F. Include, immediately after the copyright notices, a license notice
        giving the public permission to use the Modified Version under the
        terms of this License, in the form shown in the Addendum below.

     G. Preserve in that license notice the full lists of Invariant Sections
        and required Cover Texts given in the Document's license notice.

     H. Include an unaltered copy of this License.

     I. Preserve the section Entitled "History", Preserve its Title, and add to
        it an item stating at least the title, year, new authors, and publisher
        of the Modified Version as given on the Title Page. If there is no
        section Entitled "History" in the Document, create one stating the
        title, year, authors, and publisher of the Document as given on its
        Title Page, then add an item describing the Modified Version as stated
        in the previous sentence.

     J. Preserve the network location, if any, given in the Document for public
        access to a Transparent copy of the Document, and likewise the network
        locations given in the Document for previous versions it was based on.
        These may be placed in the "History" section. You may omit a network
        location for a work that was published at least four years before the
        Document itself, or if the original publisher of the version it refers
        to gives permission.

     K. For any section Entitled "Acknowledgements" or "Dedications", Preserve
        the Title of the section, and preserve in the section all the substance
        and tone of each of the contributor acknowledgements and/or dedications
        given therein.

     L. Preserve all the Invariant Sections of the Document, unaltered in their
        text and in their titles. Section numbers or the equivalent are not
        considered part of the section titles.

     M. Delete any section Entitled "Endorsements". Such a section may not be
        included in the Modified Version.

     N. Do not retitle any existing section to be Entitled "Endorsements" or to
        conflict in title with any Invariant Section.

     O. Preserve any Warranty Disclaimers.

    If the Modified Version includes new front-matter sections or appendices
    that qualify as Secondary Sections and contain no material copied from the
    Document, you may at your option designate some or all of these sections as
    invariant. To do this, add their titles to the list of Invariant Sections
    in the Modified Version's license notice. These titles must be distinct
    from any other section titles.

    You may add a section Entitled "Endorsements", provided it contains nothing
    but endorsements of your Modified Version by various parties--for example,
    statements of peer review or that the text has been approved by an
    organization as the authoritative definition of a standard.

    You may add a passage of up to five words as a Front-Cover Text, and a
    passage of up to 25 words as a Back-Cover Text, to the end of the list of
    Cover Texts in the Modified Version. Only one passage of Front-Cover Text
    and one of Back-Cover Text may be added by (or through arrangements made
    by) any one entity. If the Document already includes a cover text for the
    same cover, previously added by you or by arrangement made by the same
    entity you are acting on behalf of, you may not add another; but you may
    replace the old one, on explicit permission from the previous publisher
    that added the old one.

    The author(s) and publisher(s) of the Document do not by this License give
    permission to use their names for publicity for or to assert or imply
    endorsement of any Modified Version.

 6. COMBINING DOCUMENTS

    You may combine the Document with other documents released under this
    License, under the terms defined in section 4 above for modified versions,
    provided that you include in the combination all of the Invariant Sections
    of all of the original documents, unmodified, and list them all as
    Invariant Sections of your combined work in its license notice, and that
    you preserve all their Warranty Disclaimers.

    The combined work need only contain one copy of this License, and multiple
    identical Invariant Sections may be replaced with a single copy. If there
    are multiple Invariant Sections with the same name but different contents,
    make the title of each such section unique by adding at the end of it, in
    parentheses, the name of the original author or publisher of that section
    if known, or else a unique number. Make the same adjustment to the section
    titles in the list of Invariant Sections in the license notice of the
    combined work.

    In the combination, you must combine any sections Entitled "History" in the
    various original documents, forming one section Entitled "History";
    likewise combine any sections Entitled "Acknowledgements", and any sections
    Entitled "Dedications". You must delete all sections Entitled
    "Endorsements."

 7. COLLECTIONS OF DOCUMENTS

    You may make a collection consisting of the Document and other documents
    released under this License, and replace the individual copies of this
    License in the various documents with a single copy that is included in the
    collection, provided that you follow the rules of this License for verbatim
    copying of each of the documents in all other respects.

    You may extract a single document from such a collection, and distribute it
    individually under this License, provided you insert a copy of this License
    into the extracted document, and follow this License in all other respects
    regarding verbatim copying of that document.

 8. AGGREGATION WITH INDEPENDENT WORKS

    A compilation of the Document or its derivatives with other separate and
    independent documents or works, in or on a volume of a storage or
    distribution medium, is called an "aggregate" if the copyright resulting
    from the compilation is not used to limit the legal rights of the
    compilation's users beyond what the individual works permit. When the
    Document is included in an aggregate, this License does not apply to the
    other works in the aggregate which are not themselves derivative works of
    the Document.

    If the Cover Text requirement of section 3 is applicable to these copies of
    the Document, then if the Document is less than one half of the entire
    aggregate, the Document's Cover Texts may be placed on covers that bracket
    the Document within the aggregate, or the electronic equivalent of covers
    if the Document is in electronic form. Otherwise they must appear on
    printed covers that bracket the whole aggregate.

 9. TRANSLATION

    Translation is considered a kind of modification, so you may distribute
    translations of the Document under the terms of section 4. Replacing
    Invariant Sections with translations requires special permission from their
    copyright holders, but you may include translations of some or all
    Invariant Sections in addition to the original versions of these Invariant
    Sections. You may include a translation of this License, and all the
    license notices in the Document, and any Warranty Disclaimers, provided
    that you also include the original English version of this License and the
    original versions of those notices and disclaimers. In case of a
    disagreement between the translation and the original version of this
    License or a notice or disclaimer, the original version will prevail.

    If a section in the Document is Entitled "Acknowledgements", "Dedications",
    or "History", the requirement (section 4) to Preserve its Title (section 1)
    will typically require changing the actual title.

10. TERMINATION

    You may not copy, modify, sublicense, or distribute the Document except as
    expressly provided for under this License. Any other attempt to copy,
    modify, sublicense or distribute the Document is void, and will
    automatically terminate your rights under this License. However, parties
    who have received copies, or rights, from you under this License will not
    have their licenses terminated so long as such parties remain in full
    compliance.

11. FUTURE REVISIONS OF THIS LICENSE

    The Free Software Foundation may publish new, revised versions of the GNU
    Free Documentation License from time to time. Such new versions will be
    similar in spirit to the present version, but may differ in detail to
    address new problems or concerns. See http://www.gnu.org/copyleft/.

    Each version of the License is given a distinguishing version number. If
    the Document specifies that a particular numbered version of this License
    "or any later version" applies to it, you have the option of following the
    terms and conditions either of that specified version or of any later
    version that has been published (not as a draft) by the Free Software
    Foundation. If the Document does not specify a version number of this
    License, you may choose any version ever published (not as a draft) by the
    Free Software Foundation.

ADDENDUM: How to use this License for your documents

To use this License in a document you have written, include a copy of the
License in the document and put the following copyright and license notices
just after the title page:

Copyright (C)  year  your name.
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2
or any later version published by the Free Software Foundation;
with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
Texts.  A copy of the license is included in the section entitled ``GNU
Free Documentation License''.


If you have Invariant Sections, Front-Cover Texts and Back-Cover Texts, replace
the "with...Texts." line with this:

with the Invariant Sections being list their titles, with
the Front-Cover Texts being list, and with the Back-Cover Texts
being list.


If you have Invariant Sections without Cover Texts, or some other combination
of the three, merge those two alternatives to suit the situation.

If your document contains nontrivial examples of program code, we recommend
releasing these examples in parallel under your choice of free software
license, such as the GNU General Public License, to permit their use in free
software.

